﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MoNo;
using MoNo.OpenGL;

namespace MultiViewSample
{
  // スクリーン座標系で単純な正方形を描画するシーンクラス
  // XAMLに埋め込むためには DependencyObject を継承する必要がある
  class ScreenRectScene : System.Windows.DependencyObject, MoNo.Graphics.IScene
  {
    readonly MoNo.Graphics.IScene scene =
      GraphicsUT.CreateScene(GLPrimType.Quads, new[]
      {
        new Point3f( 10, 10, 0 ),
        new Point3f( 10, 90, 0 ),
        new Point3f( 90, 90, 0 ),
        new Point3f( 90, 10, 0 ),
      });

    public void Draw( MoNo.Graphics.ISceneContext sc )
    {
      using (var scope = sc.Push())
      {
        scope.Color = System.Drawing.Color.Khaki;
        scene.Draw(sc);
      }
    }
  }
}
