﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.FSharp.Core;
using MoNo;
using MoNo.Geometries;

namespace StandardCsTemplate
{
  public class AppModel : MoNo.Studio.StudioAppModel<Document>
  {
    public AppModel() : base( () => new Document() ) { }

    public MoNo.Progress<Unit> ImportSTL( string path )
    {
      return MoNo.Progress.ByAction( token => {
        var tris = token.Run( 0.5, STLFormat.readTris3d( true, path ) );
        var mesh = token.Run( 0.5, Mesh.ofTris3dProgressive( tris ) );
        base.Document.Val.Mesh.Val = mesh;
      } );
    }
  }
}
